package edu.uoc.main;

import java.io.IOException;

import edu.uoc.messages.ConfigMsg;

public class ConfigMsgHandler {

	private static int retries = 5;
	private static int seconds = 5;
	private static boolean recievedAck = false;
	
	public static void handleConfiguration(ConfigMsg config) {
		recievedAck = true;
	}

	public static void sendConfiguration(int moteId, ConfigMsg msg) {
		try {
			FDConfig.instance.amSender.send(moteId, msg);
			waitConfigurationAck(moteId, msg);
		} catch (IOException e) {
			if(retries > 0) {
				System.out.println("No s'ha pogut enviar la configuració. " +
						"Esperant el reenviament.");
				retries--;
				sendConfiguration(moteId, msg);
			}
		} catch (InterruptedException e) {
			System.out.println("Error en temps d\'espera: " + e.getMessage());
		}
	}
	
	public static void waitConfigurationAck(int moteId, ConfigMsg msg) throws InterruptedException {
		System.out.print("Esperant resposta de la mota " + moteId + " (queden " + retries + " intents) ");
		for(int i=0; i<seconds; i++) {
			Thread.sleep(1000);
			System.out.print(".");
			if(recievedAck) {
				break;
			}
		}
		System.out.println("");
		if(!recievedAck) {
			retries--;
			if(retries>=0)
				sendConfiguration(moteId, msg);
			else
				System.out.println("Llàstima, la mota " + moteId + " sembla que està fora de cobertura!");
		} else {
			System.out.println("La mota " + moteId + " s'ha configurat correctament!");
		}
	}

}
