package edu.uoc.main;

import net.tinyos.message.Message;
import net.tinyos.message.MessageListener;
import net.tinyos.message.MoteIF;
import net.tinyos.packet.BuildSource;
import net.tinyos.packet.PhoenixSource;
import net.tinyos.util.PrintStreamMessenger;
import edu.uoc.messages.AlarmMsg;
import edu.uoc.messages.BeaconMsg;
import edu.uoc.messages.ReportMsg;

public class FDMonitor implements MessageListener {

	public static FDMonitor instance = null;
	public MoteIF amReceiver;
	public MoteIF amSender;
	
	public static void main(String[] args) {

		instance = new FDMonitor();
		String source="sf@localhost:9002";
		PhoenixSource phoenix = BuildSource.makePhoenix(source, PrintStreamMessenger.err);

		instance.amReceiver = new MoteIF(phoenix);
		instance.amReceiver.registerListener(new AlarmMsg(),  instance);
		instance.amReceiver.registerListener(new BeaconMsg(), instance);
		instance.amReceiver.registerListener(new ReportMsg(), instance);
		
		instance.amSender = new MoteIF(phoenix);
		
	}

	@Override
	public void messageReceived(int to, Message m) {
//		System.out.println(m.toString());
		if(m instanceof BeaconMsg) {
			MessageLogger.showBeaconMessage((BeaconMsg) m);
		} else if(m instanceof AlarmMsg) {
			AlarmMsgHandler.handleAlarm((AlarmMsg) m);
		} else if(m instanceof ReportMsg) {
			ReportMsgHandler.handleReport((ReportMsg) m);
		} 
	}
	
}
