package edu.uoc.timecontrol;

import java.util.Timer;

public class BatteryTimer {

	private Timer timer;
	private CheckReportPeriod crp;

	public BatteryTimer(int moteId, int periodMs) {
		timer = new Timer();
		crp = new CheckReportPeriod(moteId, periodMs, System.currentTimeMillis());
		timer.scheduleAtFixedRate(crp, 0, periodMs);
	}

	public void updateLastReception() {
		crp.setLastReception(System.currentTimeMillis());
	}
	
	public void updatePeriod(int newPeriod) {
		crp.setPeriodInMs(newPeriod);
		timer.scheduleAtFixedRate(crp, 0, newPeriod);
	}
	
}