package edu.uoc.timecontrol;

import java.util.TimerTask;

import edu.uoc.main.ReportMsgHandler;

public class CheckReportPeriod extends TimerTask {

	private final int MAX_RETRIES = 2;
	
	private int moteId;
	private int periodInMs;
	private int currentRetries;
	private long lastReception;
	
	public CheckReportPeriod(int moteId, int periodInMs, long lastReception) {
		this.moteId = moteId;
		this.periodInMs = periodInMs;
		this.lastReception = lastReception;
		this.currentRetries = 0;
	}

	public int getPeriodInMs() {
		return periodInMs;
	}

	public void setPeriodInMs(int periodInMs) {
		this.periodInMs = periodInMs;
	}

	public long getLastReception() {
		return lastReception;
	}

	public void setLastReception(long lastReception) {
		this.lastReception = lastReception;
	}

	@Override
	public void run() {
		if(System.currentTimeMillis() - lastReception > periodInMs) {
			if(currentRetries > MAX_RETRIES) {
				System.out.println("Avís! La mota " + moteId + " està fora de cobertura.");
				ReportMsgHandler.batteryTimers.remove(moteId);
				this.cancel();
			} else {
				currentRetries++;
			}
		} else {
			currentRetries = 0;
		}
	}

}
